import type { ThemeConfig } from "tailwindcss/types/config";

export type RemoveIndex<T> = {
  [P in keyof T as string extends P ? never : number extends P ? never : P]: T[P];
};

export type KnownKeys<T> = keyof RemoveIndex<T>;

export type SetPartialProps<Type, Props extends keyof Type> = Partial<Pick<Type, Props>> &
  Omit<Type, Props>;

export type SetRequiredProps<Type, Props extends keyof Type> = Required<
  Pick<Type, Props>
> &
  Type;

export type ConverterMappingKey = Exclude<
  KnownKeys<ThemeConfig>,
  "keyframes" | "container" | "fontFamily"
>;

export type ConverterMapping = Record<ConverterMappingKey, Record<string, string>> &
  Record<"aria" | "data" | "supports", Record<string, string> | undefined>;
